//package Aufgabe;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import javax.swing.*;
import java.lang.reflect.Array;
import java.beans.*;
import java.util.HashMap;
import java.util.Map;
import java.util.Collection;
import java.util.Iterator;
import java.util.ArrayList;
import java.util.List;
import javax.swing.border.*;
import java.net.URL;
import java.net.MalformedURLException;


/**
 * <p>Überschrift: Aufgabentrainer Congestion Control</p>
 * <p>Beschreibung: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Organisation: </p>
 * @author Christine Kapp
 * @version 1.0
 */

public class Aufgabentrainer extends JApplet {
  boolean isStandalone = false;
  Frame myFrame = new Frame("Congestion Control");
  String benutzer="";
  String passwort="";
  JTabbedPane jTabbedPaneAufgabentypen = new JTabbedPane();
  Panel panelAufgabe2 = new Panel();
  Aufgabentyp1 aufgabe1;
  Aufgabentyp2 aufgabe2;
  Aufgabentyp3 aufgabe3;
  Map ErgebnisEingabe;
  List eingaben3;
  DrawGrafik2 grafik2;
  DrawGrafik3 grafik3;
  List ergebnis3;
  long zeitbedarf1, zeitbedarf2, zeitbedarf3;
  final int Timeout=0;
  final int TDACK=1;
  Button buttonOK2 = new Button();
  MenuBar jMenubarAufgabentrainer = new MenuBar();
  Menu jMenuHelp = new Menu("Help");
  Menu jMenuProgram = new Menu("Program");
  MenuItem jMenuItemQuit = new MenuItem("Quit");
  Menu jMenuCustomize = new Menu("Customize");
  Menu jMenuView = new Menu("View");
  MenuItem jMenuItemAufgabentyp3 = new MenuItem("zeichnen");
  MenuItem jMenuItemAufgabentyp2 = new MenuItem("auswerten");
  MenuItem jMenuItemAufgabentyp1 = new MenuItem("berechnen");
  MenuItem jMenuItemBereichx = new MenuItem("maximale Rundenzahl");
  MenuItem jMenuItemAnzahlAktionen = new MenuItem("Anzahl der Aktionen");
  MenuItem jMenuItemHilfe = new MenuItem("Hilfe");
  Panel panelAufgabe3 = new Panel();
  Label labelAnzahl3 = new Label();
  Label labelRundenzahl3 = new Label();
  TextField textFieldAnzahl3 = new TextField();
  TextField textFieldRundenzahl3 = new TextField();
  Button buttonAufgabe3Erzeugen = new Button();
  Panel panelEingabeErgebnisse3 = new Panel();
  Panel panelAnzeigeErgebnisse3 = new Panel();
  Label labelAnfangspunkt = new Label();
  Label labelEndpunkt = new Label();
  Label labelFunktion = new Label();
  TextField textFieldAnfangspunkt = new TextField();
  TextField textFieldEndpunkt = new TextField();
  Choice choiceFunktion = new Choice();
  Button buttonWertEingeben = new Button();
  BorderLayout borderLayout3 = new BorderLayout();
  Button buttonOK3 = new Button();
  BorderLayout borderLayout1 = new BorderLayout();
  JPanel jPanelEinstellungen2 = new JPanel();
  TextField textFieldRundenzahl2 = new TextField();
  Label labelAnzahl2 = new Label();
  Label labelRundenzahl2 = new Label();
  TextField textFieldAnzahl2 = new TextField();
  Button buttonAufgabe2Erzeugen = new Button();
  Border border1;
  TitledBorder titledBorder1;
  BorderLayout borderLayout4 = new BorderLayout();
  JPanel jPanelAnzeigeGrafik = new JPanel();
  BorderLayout borderLayout2 = new BorderLayout();
  Border border2;
  TitledBorder titledBorder2;
  Border border3;
  TitledBorder titledBorder3;
  Border border4;
  TitledBorder titledBorder4;
  Border border5;
  TitledBorder titledBorder5;
  Border border6;
  TitledBorder titledBorder6;
  Border border7;
  TitledBorder titledBorder7;
  Border border8;
  TitledBorder titledBorder8;
  Label labelAnzeigeAufgabe2 = new Label();
  JPanel jPanelEinstellungen3 = new JPanel();
  Border border9;
  TitledBorder titledBorder9;
  Border border10;
  TitledBorder titledBorder10;
  JPanel jPanelErgebniseingabe3 = new JPanel();
  Border border11;
  TitledBorder titledBorder11;
  JPanel jPanelErgenisse3 = new JPanel();
  Border border12;
  TitledBorder titledBorder12;
  Panel panelAnzeigeGrafik = new Panel();
  BorderLayout borderLayout5 = new BorderLayout();
  Label labelErgebnis2 = new Label();
  JPanel jPanelErgebniseingabe = new JPanel();
  Border border13;
  TitledBorder titledBorder13;
  Button buttonAufgabe1Erzeugen = new Button();
  Label labelssthresh = new Label();
  Label labelErgebnis1 = new Label();
  TextField textFieldCongestionWindow = new TextField();
  JPanel jPanelAnzeigeErgebniseingabe1 = new JPanel();
  TextField textFieldAnzahl1 = new TextField();
  TextField textFieldssthresh = new TextField();
  JPanel jPanelEinstellungen1 = new JPanel();
  Button buttonOK1 = new Button();
  Panel panelAufgabe1 = new Panel();
  Label labelRundenzahl1 = new Label();
  Label labelAnzahl1 = new Label();
  Label labelCongestionWindow = new Label();
  TextField textFieldRundenzahl1 = new TextField();
  Label labelErgebnis3 = new Label();
  JPanel jPanelAnzeigeAufgabe1 = new JPanel();
  TextArea textAreaAnzeigeAufgabe1 = new TextArea();
  JPanel jPanelAnzeigeAufgabe3 = new JPanel();
  TextArea textAreaAnzeigeAufgabe3 = new TextArea();
  GridLayout gridLayout1 = new GridLayout();
  GridLayout gridLayout2 = new GridLayout();
  JScrollPane jScrollPane1 = new JScrollPane(jPanelErgebniseingabe);
  Button buttonSenden1 = new Button();
  Button buttonSenden2 = new Button();
  Button buttonSenden3 = new Button();

  //Parameterwert holen
  public String getParameter(String key, String def) {
    return isStandalone ? System.getProperty(key, def) :
      (getParameter(key) != null ? getParameter(key) : def);
  }

  //Das Applet konstruieren
  public Aufgabentrainer() {
  }
  //Das Applet initialisieren
  public void init() {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  //Initialisierung der Komponenten
  private void jbInit() throws Exception {
    border1 = BorderFactory.createEtchedBorder(Color.white,new Color(142, 142, 142));
    titledBorder1 = new TitledBorder(new EtchedBorder(EtchedBorder.RAISED,Color.lightGray,new Color(142, 142, 142)),"Einstellungen");
    border2 = BorderFactory.createEtchedBorder(Color.white,new Color(178, 178, 178));
    titledBorder2 = new TitledBorder(new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(178, 178, 178)),"Congestion Control Kurve");
    border3 = BorderFactory.createEtchedBorder(Color.white,new Color(142, 142, 142));
    titledBorder3 = new TitledBorder(border3,"Ergebnisse");
    border4 = BorderFactory.createEtchedBorder(Color.white,new Color(142, 142, 142));
    titledBorder4 = new TitledBorder(BorderFactory.createEtchedBorder(Color.white,new Color(142, 142, 142)),"Ergebnisse");
    border5 = new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(148, 145, 140));
    titledBorder5 = new TitledBorder(new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(148, 145, 140)),"Einstellungen");
    border6 = BorderFactory.createEtchedBorder(Color.white,new Color(148, 145, 140));
    titledBorder6 = new TitledBorder(border6,"Aufgabe");
    border7 = new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(148, 145, 140));
    titledBorder7 = new TitledBorder(border7,"Ergebnis");
    border8 = BorderFactory.createEtchedBorder(Color.white,new Color(148, 145, 140));
    titledBorder8 = new TitledBorder(new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(148, 145, 140)),"Ergebnis");
    border9 = new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(148, 145, 140));
    titledBorder9 = new TitledBorder(border9,"Einstellungen");
    border10 = BorderFactory.createEtchedBorder(Color.white,new Color(148, 145, 140));
    titledBorder10 = new TitledBorder(new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(148, 145, 140)),"Aufgabe");
    border11 = new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(148, 145, 140));
    titledBorder11 = new TitledBorder(border11,"Ergebniseingabe");
    border12 = new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(148, 145, 140));
    titledBorder12 = new TitledBorder(border12,"Ergebnisse");
    border13 = new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(178, 178, 178));
    titledBorder13 = new TitledBorder(new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(178, 178, 178)),"Ergebnisse");
    this.getContentPane().setLayout(borderLayout1);
    panelAufgabe2.setLayout(null);
    buttonOK2.setFont(new java.awt.Font("Serif", 0, 12));
    buttonOK2.setLabel("Testen");
    buttonOK2.setBounds(new Rectangle(318, 599, 75, 25));
    buttonOK2.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(MouseEvent e) {
        buttonOK2_mouseClicked(e);}});

    labelAnzahl3.setText("Anzahl der  Aktionen:");
    labelAnzahl3.setBounds(new Rectangle(9, 26, 124, 27));
    panelAufgabe3.setLayout(null);
    labelRundenzahl3.setText("maximale Rundenzahl:");
    labelRundenzahl3.setBounds(new Rectangle(10, 54, 133, 27));
    textFieldAnzahl3.setText("3");
    textFieldAnzahl3.setBounds(new Rectangle(174, 25, 119, 25));
    textFieldRundenzahl3.setText("50");
    textFieldRundenzahl3.setBounds(new Rectangle(174, 56, 119, 25));
    buttonAufgabe3Erzeugen.setFont(new java.awt.Font("Serif", 0, 12));
    buttonAufgabe3Erzeugen.setLabel("Aufgabe erzeugen");
    buttonAufgabe3Erzeugen.setBounds(new Rectangle(313, 56, 119, 25));
    buttonAufgabe3Erzeugen.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(MouseEvent e) {
        buttonAufgabe3Erzeugen_mouseClicked(e);
      }
    });

    panelEingabeErgebnisse3.setBounds(new Rectangle(7, 231, 521, 82));
    panelEingabeErgebnisse3.setLayout(null);
    panelAnzeigeErgebnisse3.setBackground(Color.white);
    panelAnzeigeErgebnisse3.setBounds(new Rectangle(11, 20, 417, 248));
    panelAnzeigeErgebnisse3.setLayout(borderLayout3);
    labelAnfangspunkt.setText("Anfang x");
    labelAnfangspunkt.setBounds(new Rectangle(11, 19, 55, 17));
    labelEndpunkt.setText("Ende x");
    labelEndpunkt.setBounds(new Rectangle(63, 20, 46, 17));
    labelFunktion.setText("Funktion");
    labelFunktion.setBounds(new Rectangle(111, 20, 62, 17));
    textFieldAnfangspunkt.setText("0");
    textFieldAnfangspunkt.setBounds(new Rectangle(12, 36, 47, 21));
    textFieldEndpunkt.setText("0");
    textFieldEndpunkt.setBounds(new Rectangle(63, 36, 45, 21));
    buttonWertEingeben.setFont(new java.awt.Font("Serif", 0, 12));
    buttonWertEingeben.setLabel(" eingeben");
    buttonWertEingeben.setBounds(new Rectangle(207, 36, 78, 21));
    buttonWertEingeben.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        buttonWertEingeben_actionPerformed(e);
      }
    });
    buttonWertEingeben.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(MouseEvent e) {
        buttonWertEingeben_mouseClicked(e);
      }
    });
    choiceFunktion.setBounds(new Rectangle(111, 36, 93, 21));
    buttonOK3.setFont(new java.awt.Font("Serif", 0, 12));
    buttonOK3.setLabel("Testen");
    buttonOK3.setBounds(new Rectangle(289, 36, 67, 21));
    buttonOK3.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        buttonOK3_actionPerformed(e);
      }
    });
    jPanelEinstellungen2.setBorder(titledBorder1);
    jPanelEinstellungen2.setBounds(new Rectangle(7, 5, 472, 96));
    jPanelEinstellungen2.setLayout(null);
    textFieldRundenzahl2.setText("50");
    textFieldRundenzahl2.setBounds(new Rectangle(179, 57, 119, 27));
    labelAnzahl2.setText("Anzahl der Aktionen:");
    labelAnzahl2.setBounds(new Rectangle(10, 23, 116, 27));
    labelRundenzahl2.setText("maximale Rundenzahl: ");
    labelRundenzahl2.setBounds(new Rectangle(8, 59, 142, 27));
    textFieldAnzahl2.setText("3");
    textFieldAnzahl2.setBounds(new Rectangle(179, 23, 119, 27));
    buttonAufgabe2Erzeugen.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(MouseEvent e) {
        buttonAufgabe2Erzeugen_mouseClicked(e);
      }
    });
    buttonAufgabe2Erzeugen.setFont(new java.awt.Font("Serif", 0, 12));
    buttonAufgabe2Erzeugen.setLabel("Aufgabe erzeugen");
    buttonAufgabe2Erzeugen.setBounds(new Rectangle(338, 58, 119, 27));
    jPanelAnzeigeGrafik.setBounds(new Rectangle(26, 114, 484, 287));
    jPanelAnzeigeGrafik.setLayout(borderLayout4);
    jPanelAnzeigeGrafik.setBorder(titledBorder2);
    jPanelAnzeigeGrafik.setBounds(new Rectangle(9, 110, 467, 318));
    jPanelAnzeigeGrafik.setLayout(borderLayout2);
    jPanelEinstellungen3.setBorder(titledBorder9);
    jPanelEinstellungen3.setBounds(new Rectangle(7, 0, 446, 92));
    jPanelEinstellungen3.setLayout(null);
    jPanelErgebniseingabe3.setBorder(titledBorder11);
    jPanelErgebniseingabe3.setBounds(new Rectangle(4, 2, 444, 66));
    jPanelErgebniseingabe3.setLayout(null);
    jPanelErgenisse3.setBorder(titledBorder12);
    jPanelErgenisse3.setBounds(new Rectangle(14, 336, 441, 280));
    jPanelErgenisse3.setLayout(null);
    panelAnzeigeGrafik.setBackground(Color.white);
    panelAnzeigeGrafik.setLayout(borderLayout5);
    labelAnzeigeAufgabe2.setBounds(new Rectangle(12, 425, 456, 27));
    labelErgebnis2.setFont(new java.awt.Font("Serif", 2, 12));
    labelErgebnis2.setForeground(Color.blue);
    labelErgebnis2.setBounds(new Rectangle(11, 599, 303, 25));
    jPanelErgebniseingabe.setBackground(Color.white);
    //jPanelErgebniseingabe.setBorder(titledBorder13);
    jPanelErgebniseingabe.setLayout(new GridLayout(0,2,3,3));
    buttonAufgabe1Erzeugen.setFont(new java.awt.Font("Serif", 0, 12));
    buttonAufgabe1Erzeugen.setLabel("Aufgabe erzeugen");
    buttonAufgabe1Erzeugen.setBounds(new Rectangle(329, 56, 127, 27));
    buttonAufgabe1Erzeugen.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(MouseEvent e) {
        buttonAufgabe1Erzeugen_mouseClicked(e);
      }
    });
    labelssthresh.setText("ssthresh:");
    labelssthresh.setBounds(new Rectangle(18, 68, 52, 17));
    labelErgebnis1.setFont(new java.awt.Font("Serif", 2, 12));
    labelErgebnis1.setForeground(Color.blue);
    labelErgebnis1.setBounds(new Rectangle(15, 112, 427, 32));
    textFieldCongestionWindow.setText("0");
    textFieldCongestionWindow.setBounds(new Rectangle(169, 26, 70, 29));
    jPanelAnzeigeErgebniseingabe1.setBorder(titledBorder8);
    jPanelAnzeigeErgebniseingabe1.setBounds(new Rectangle(4, 262, 467, 157));
    jPanelAnzeigeErgebniseingabe1.setLayout(null);
    textFieldAnzahl1.setText("3");
    textFieldAnzahl1.setBounds(new Rectangle(177, 22, 127, 26));
    textFieldssthresh.setText("64");
    textFieldssthresh.setBounds(new Rectangle(170, 64, 70, 29));
    jPanelEinstellungen1.setBorder(titledBorder5);
    jPanelEinstellungen1.setBounds(new Rectangle(6, 3, 467, 91));
    jPanelEinstellungen1.setLayout(null);
    buttonOK1.setFont(new java.awt.Font("Serif", 0, 12));
    buttonOK1.setLabel("Testen");
    buttonOK1.setBounds(new Rectangle(256, 66, 78, 27));
    buttonOK1.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(MouseEvent e) {
        buttonOK1_mouseClicked(e);
      }
    });
    panelAufgabe1.setLayout(null);
    labelRundenzahl1.setText("maximale Rundenzahl: ");
    labelRundenzahl1.setBounds(new Rectangle(11, 57, 141, 25));
    labelAnzahl1.setText("Anzahl der Aktionen:");
    labelAnzahl1.setBounds(new Rectangle(9, 24, 141, 25));
    labelCongestionWindow.setText("CongestionWindow:");
    labelCongestionWindow.setBounds(new Rectangle(17, 38, 111, 17));
    textFieldRundenzahl1.setText("50");
    textFieldRundenzahl1.setBounds(new Rectangle(176, 56, 127, 26));
    labelErgebnis3.setFont(new java.awt.Font("Serif", 2, 12));
    labelErgebnis3.setForeground(Color.blue);
    labelErgebnis3.setBounds(new Rectangle(14, 598, 439, 23));
    jPanelAnzeigeAufgabe1.setBorder(titledBorder10);
    jPanelAnzeigeAufgabe1.setBounds(new Rectangle(7, 108, 467, 148));
    jPanelAnzeigeAufgabe1.setLayout(gridLayout2);
    textAreaAnzeigeAufgabe1.setBackground(new Color(204, 204, 204));
    jPanelAnzeigeAufgabe3.setBorder(titledBorder10);
    jPanelAnzeigeAufgabe3.setBounds(new Rectangle(8, 100, 446, 128));
    jPanelAnzeigeAufgabe3.setLayout(gridLayout1);
    textAreaAnzeigeAufgabe3.setBackground(new Color(204, 204, 204));
    jTabbedPaneAufgabentypen.setBackground(new Color(204, 204, 204));
    jTabbedPaneAufgabentypen.setPreferredSize(new Dimension(512, 750));
    jTabbedPaneAufgabentypen.setBounds(new Rectangle(0, 0, 513, 750));
    panelAufgabe1.setBackground(new Color(204, 204, 204));
    panelAufgabe2.setBackground(new Color(204, 204, 204));
    panelAufgabe3.setBackground(new Color(204, 204, 204));
    myFrame.setBackground(new Color(204, 204, 204));
    jScrollPane1.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
    jScrollPane1.setBorder(titledBorder13);
    jScrollPane1.setBounds(new Rectangle(11, 464, 462, 126));
    jScrollPane1.setPreferredSize(new Dimension(462,123));
    buttonSenden1.setFont(new java.awt.Font("Serif", 0, 12));
    buttonSenden1.setLabel("Senden");
    buttonSenden1.setBounds(new Rectangle(343, 66, 78, 27));
    buttonSenden1.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(MouseEvent e) {
        buttonSenden1_mouseClicked(e);
      }
    });
    buttonSenden2.setFont(new java.awt.Font("Serif", 0, 12));
    buttonSenden2.setLabel("Senden");
    buttonSenden2.setBounds(new Rectangle(396, 599, 75, 25));
    buttonSenden2.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(MouseEvent e) {
        buttonSenden2_mouseClicked(e);
      }
    });
    buttonSenden3.setFont(new java.awt.Font("Serif", 0, 12));
    buttonSenden3.setLabel("Senden");
    buttonSenden3.setBounds(new Rectangle(361, 36, 71, 21));
    buttonSenden3.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        buttonSenden3_actionPerformed(e);
      }
    });
    jPanelEinstellungen3.add(textFieldRundenzahl3, null);
    jPanelEinstellungen3.add(buttonAufgabe3Erzeugen, null);
    jPanelEinstellungen3.add(labelRundenzahl3, null);
    jPanelEinstellungen3.add(labelAnzahl3, null);
    jPanelEinstellungen3.add(textFieldAnzahl3, null);
    panelAufgabe3.add(jPanelErgenisse3, null);
    jPanelErgenisse3.add(panelAnzeigeErgebnisse3, null);
    panelAufgabe3.add(jPanelAnzeigeAufgabe3, null);
    jPanelAnzeigeAufgabe3.add(textAreaAnzeigeAufgabe3, null);
    panelAufgabe3.add(labelErgebnis3, null);
    panelAufgabe3.add(panelEingabeErgebnisse3, null);
    panelEingabeErgebnisse3.add(jPanelErgebniseingabe3, null);

    jMenubarAufgabentrainer.add(jMenuProgram);
    jMenubarAufgabentrainer.add(jMenuView);
    jMenubarAufgabentrainer.add(jMenuCustomize);
    jMenubarAufgabentrainer.add(jMenuHelp);
    jMenuProgram.add(jMenuItemQuit);
    jMenuView.add(jMenuItemAufgabentyp1);
    jMenuView.add(jMenuItemAufgabentyp2);
    jMenuView.add(jMenuItemAufgabentyp3);
    jMenuCustomize.add(jMenuItemAnzahlAktionen);
    jMenuCustomize.add(jMenuItemBereichx);
    jMenuHelp.add(jMenuItemHilfe);
    choiceFunktion.add("Timeout");
    choiceFunktion.add("TDACK");
    choiceFunktion.add("linear");
    choiceFunktion.add("2^x");
    choiceFunktion.add("x^2");
    choiceFunktion.add("e^x");
    jPanelEinstellungen2.add(textFieldRundenzahl2, null);
    jPanelEinstellungen2.add(labelAnzahl2, null);
    jPanelEinstellungen2.add(labelRundenzahl2, null);
    jPanelEinstellungen2.add(textFieldAnzahl2, null);
    jPanelEinstellungen2.add(buttonAufgabe2Erzeugen, null);
    panelAufgabe2.add(labelErgebnis2, null);
    panelAufgabe2.add(jScrollPane1, null);
    //jScrollPane1.getViewport().add(jPanelErgebniseingabe, null);
    panelAufgabe2.add(labelAnzeigeAufgabe2, null);
    panelAufgabe2.add(jPanelAnzeigeGrafik, null);
    jPanelAnzeigeGrafik.add(panelAnzeigeGrafik, BorderLayout.CENTER);
    panelAufgabe2.add(jPanelEinstellungen2, null);
    jPanelErgebniseingabe3.add(textFieldAnfangspunkt, null);
    jPanelErgebniseingabe3.add(labelAnfangspunkt, null);
    panelAufgabe3.add(jPanelEinstellungen3, null);
    this.getContentPane().add(jTabbedPaneAufgabentypen, BorderLayout.CENTER);
    jPanelAnzeigeErgebniseingabe1.add(labelssthresh, null);
    jPanelAnzeigeErgebniseingabe1.add(labelCongestionWindow, null);
    jPanelAnzeigeErgebniseingabe1.add(textFieldCongestionWindow, null);
    jPanelAnzeigeErgebniseingabe1.add(textFieldssthresh, null);
    jPanelAnzeigeErgebniseingabe1.add(labelErgebnis1, null);
    jPanelAnzeigeErgebniseingabe1.add(buttonOK1, null);
    jPanelAnzeigeErgebniseingabe1.add(buttonSenden1, null);
    panelAufgabe1.add(jPanelAnzeigeAufgabe1, null);
    jPanelAnzeigeAufgabe1.add(textAreaAnzeigeAufgabe1, null);
    panelAufgabe1.add(jPanelEinstellungen1, null);
    jPanelEinstellungen1.add(textFieldRundenzahl1, null);
    jPanelEinstellungen1.add(textFieldAnzahl1, null);
    jPanelEinstellungen1.add(buttonAufgabe1Erzeugen, null);
    jPanelEinstellungen1.add(labelRundenzahl1, null);
    jPanelEinstellungen1.add(labelAnzahl1, null);
    panelAufgabe1.add(jPanelAnzeigeErgebniseingabe1, null);

	jTabbedPaneAufgabentypen.add(panelAufgabe1, "berechnen");
	jTabbedPaneAufgabentypen.add(panelAufgabe2, "auswerten");
	jTabbedPaneAufgabentypen.add(panelAufgabe3, "zeichnen");

    myFrame.setMenuBar(jMenubarAufgabentrainer);
    myFrame.add(jTabbedPaneAufgabentypen);
    panelAufgabe2.add(buttonOK2, null);
    panelAufgabe2.add(buttonSenden2, null);
    jPanelErgebniseingabe3.add(textFieldEndpunkt, null);
    jPanelErgebniseingabe3.add(labelEndpunkt, null);
    jPanelErgebniseingabe3.add(choiceFunktion, null);
    jPanelErgebniseingabe3.add(labelFunktion, null);
    jPanelErgebniseingabe3.add(buttonWertEingeben, null);
    jPanelErgebniseingabe3.add(buttonOK3, null);
    jPanelErgebniseingabe3.add(buttonSenden3, null);

    ActionListener lis = new ActionListener(){
		public void actionPerformed(ActionEvent e){
			aufgabentyp_ActionPerformed(e);		}
	};
	ActionListener pro = new ActionListener(){
			public void actionPerformed(ActionEvent e){
				program_ActionPerformed(e);		}
	};
	ActionListener eins = new ActionListener(){
			public void actionPerformed(ActionEvent e){
				einstellungen_ActionPerformed(e);		}
	};
	ActionListener help = new ActionListener(){
			public void actionPerformed(ActionEvent e){
				try {
				help_ActionPerformed(e);}
				catch (MalformedURLException ign){ign.printStackTrace();};
			}
	};
	WindowListener win = new WindowAdapter(){
		public void windowClosing(WindowEvent e){
				quit_windowClosing(e);
		}
	};


	jMenuItemAufgabentyp1.addActionListener(lis);
	jMenuItemAufgabentyp2.addActionListener(lis);
	jMenuItemAufgabentyp3.addActionListener(lis);
	jMenuItemAnzahlAktionen.addActionListener(eins);
	jMenuItemBereichx.addActionListener(eins);
	jMenuItemQuit.addActionListener(pro);
	jMenuItemHilfe.addActionListener(help);
	myFrame.addWindowListener(win);
	myFrame.setSize(new Dimension(500, 750));
    }


  //Das Applet starten
  public void start() {
	  zeitbedarf1 = 0;
	  zeitbedarf2 = 0;
	  zeitbedarf3 = 0;

	  final JDialog dialog = new JDialog(myFrame,"Passwort",true);

	  dialog.getContentPane().setLayout(new GridLayout(3,2,5,5));

	  final JTextField benutzerfeld = new JTextField();
	  final JPasswordField passwortfeld = new JPasswordField();
	  JButton ok = new JButton("OK");
	  dialog.getContentPane().add(new JLabel("Benutzername: "));
	  dialog.getContentPane().add(benutzerfeld);
	  dialog.getContentPane().add(new JLabel("Passwort: "));
	  dialog.getContentPane().add(passwortfeld);
	  dialog.getContentPane().add(ok);

	  ActionListener lis = new ActionListener()
	  {
		  public void actionPerformed(ActionEvent e)
		  {
			  benutzer = benutzerfeld.getText();
			  passwort = new String(passwortfeld.getPassword());
			  dialog.dispose();
		  };
	  };

	  ok.addActionListener(lis);


	  dialog.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
	  dialog.pack();
	  dialog.setVisible(true);
	  dialog.setLocationRelativeTo(null);

	  myFrame.setVisible(true);
      myFrame.setLocationRelativeTo(null);
  }


  //Das Applet anhalten
  public void stop() {
	  zeitbedarf1 = 0;
	  zeitbedarf2 = 0;
	  zeitbedarf3 = 0;
  }


  //Das Applet löschen
  public void destroy() {
  }


  //Applet-Information holen
  public String getAppletInfo() {
    return "Applet-Information";
  }


  //Parameter-Infos holen
  public String[][] getParameterInfo() {
    return null;
  }

  /** Aufgabe 1 erzeugen und anzeigen */
  void buttonAufgabe1Erzeugen_mouseClicked(MouseEvent e) {

	// Wenn Anzahl größer Bereich, dann Bereich beschränken
	if (Integer.parseInt(textFieldAnzahl1.getText()) > Integer.parseInt(textFieldRundenzahl1.getText()))
    	textFieldAnzahl1.setText(textFieldRundenzahl1.getText());

    // Parameter für Aufgabentyp holen
    int anzahl = Integer.parseInt(textFieldAnzahl1.getText());
    int bereich = Integer.parseInt(textFieldRundenzahl1.getText());
    List anzeigeliste = new ArrayList();
    // Klasse Aufgabentyp1 erzeugen
    aufgabe1 = new Aufgabentyp1(bereich, anzahl);
    // Aufgabe anzeigen
    textAreaAnzeigeAufgabe1.setText(aufgabe1.createAufgabe());
    // Label für Anzeige des Ergebnisses leeren
    labelErgebnis1.setText("");
    zeitbedarf1 = System.currentTimeMillis();

    buttonSenden1.setEnabled(true);
  }


  /** Aufgabe 2 erzeugen und anzeigen */
  void buttonAufgabe2Erzeugen_mouseClicked(MouseEvent e) {

    // Wenn Anzahl größer Bereich, dann Bereich beschränken
    if (Integer.parseInt(textFieldAnzahl2.getText()) > Integer.parseInt(textFieldRundenzahl2.getText()))
    	textFieldAnzahl2.setText(textFieldRundenzahl2.getText());

    // Anzeigen für neue Aufgabe löschen
    panelAnzeigeGrafik.removeAll();
    jPanelErgebniseingabe.removeAll();
    String aufgabentext = "";
    ErgebnisEingabe = new HashMap();
    int [] xPoints;
    int [] werte = new int[Integer.parseInt(textFieldRundenzahl2.getText())];
    // Parameter für Aufgabentyp holen
    int anzahl = Integer.parseInt(textFieldAnzahl2.getText());
    int bereich = Integer.parseInt(textFieldRundenzahl2.getText());
    // Klasse Aufgabentyp1 erzeugen
    aufgabe2 = new Aufgabentyp2(bereich, anzahl);
    // Aufgabe anzeigen
    // y-Werte also Congestion Window Größen für
    // alle x-Werte von 1 bis maximale Rundenzahl
    werte = aufgabe2.createAufgabe();
    // x-Werte von 1 bis maximale Rundenzahl mit Schrittgröße 1
    // in einem Arra<y festhalten
    xPoints = new int[Array.getLength(werte)];
    for (int i=0; i< Array.getLength(werte); i++)
    {
    	xPoints[i]=i+1;

    }

    // Aufgabentext anzeigen
    aufgabentext = "Geben Sie Zeitpunkt und Art der Aktionen an sowie den letzten Schwellenwert.";
	labelAnzeigeAufgabe2.setText(aufgabentext);

    // Kurve zeichnen mitgegeben Wertepaaren xPoints, werte
    grafik2 = new DrawGrafik2(xPoints, werte, Array.getLength(werte));
    panelAnzeigeGrafik.add(grafik2);
    // Eingabefelder für Antwort vorbereiten

    for (int i=0; i< Integer.parseInt(textFieldAnzahl2.getText()); i++)
	{
               // TextFeld zur Eingabe des Zeitpunktes
               JTextField xwert = new JTextField("0");

               // Auswahlfeld zur Auswahl des stattgefundenen Ereignisses
               JComboBox auswahl = new JComboBox();
               auswahl.addItem("TDACK");
               auswahl.addItem("Timeout");

               // in Ergebnismap aufnehmen, um später darauf zugreifen zu können.
               ErgebnisEingabe.put("Zeitpunkt"+Integer.toString(i), xwert);
               ErgebnisEingabe.put("Aktion"+Integer.toString(i), auswahl);
               // Eingabefelder auf Panel positionieren
               jPanelErgebniseingabe.add(xwert);
               jPanelErgebniseingabe.add(auswahl);

	}
	JLabel lssthresh = new JLabel("ssthresh:   ");

	jPanelErgebniseingabe.add(lssthresh);
	JTextField tfssthresh = new JTextField("0");

	jPanelErgebniseingabe.add(tfssthresh);
	ErgebnisEingabe.put("ssthresh", tfssthresh);

	jScrollPane1.repaint();
	jScrollPane1.revalidate();

	zeitbedarf2 = System.currentTimeMillis();

	buttonSenden2.setEnabled(true);
	myFrame.repaint();
  }


  /** Lösung der Aufgabe 1 überprüfen und richtiges Ergebnis anzeigen */
  boolean buttonOK1_mouseClicked(MouseEvent e) {
    try
    {
		boolean ergebnis;
		int [] werte;
		String anzeige;
		zeitbedarf1 = System.currentTimeMillis() - zeitbedarf1;
		// Eingaben überprüfen
		List controls = new ArrayList();
		controls.add(textFieldCongestionWindow.getText());
		controls.add(textFieldssthresh.getText());
		ergebnis = aufgabe1.doCheck(controls);
		// Anzeige des Ergebnisses
		werte = aufgabe1.getErgebnis();
		if (ergebnis == true)
			anzeige = "Richtig!";
		else
			anzeige = "Leider falsch. Richtiges Ergebnis ist: cwnd="+Integer.toString(werte[0])+", sstrehsh="+Integer.toString(werte[1])+". ";
		labelErgebnis1.setText(anzeige);

		buttonSenden1.setEnabled(false);

		return ergebnis;

	}
	catch (NullPointerException ign)
	{System.out.println("Zunächst Aufgabe erzeugen");
		return false;}
  }


  /** Lösung der Aufgabe 2 überprüfen und richtiges Ergebnis anzeigen */
  boolean buttonOK2_mouseClicked(MouseEvent e) {
  	try
  	{
		// Übergabe der Eingaben an Methode doCheck()
		boolean ergebnis = false;
		List controls = new ArrayList();
		JComboBox aktionsart;
		JTextField eingabe;
		zeitbedarf2 = System.currentTimeMillis() - zeitbedarf2;
		for (int i=0; i<(ErgebnisEingabe.size()-1)/2; i++)
		{
			eingabe = (JTextField)ErgebnisEingabe.get("Zeitpunkt"+Integer.toString(i));
			controls.add(eingabe.getText());
			aktionsart = (JComboBox)ErgebnisEingabe.get("Aktion"+Integer.toString(i));
			if (aktionsart.getSelectedItem() == "TDACK")
				controls.add(Integer.toString(TDACK));
			else if (aktionsart.getSelectedItem() == "Timeout")
				controls.add(Integer.toString(Timeout));
			else
				controls.add(Integer.toString(-1));
		}
		eingabe = (JTextField)ErgebnisEingabe.get("ssthresh");
		controls.add(eingabe.getText());

		// Überprüfung des eingegebenen Ergebnisses
		ergebnis = aufgabe2.doCheck(controls);

		// Anzeige des Ergebnisses
		if (ergebnis == true)
			labelErgebnis2.setText("Richtig!");
		else
			labelErgebnis2.setText("Falsch! Richtiges Ergebnis ist oben blau dargestellt.");
		List ergebnisListe = new ArrayList();
		ergebnisListe = aufgabe2.getErgebnis();


		// Ausgabe des richtigen Ergebnisses.
		int j=0;
		for (int i=0; i< (ergebnisListe.size()-1)/2; i++)
		{
			// Label zur Anzeige des richtigen Zeitpunkt
			JLabel xwert = new JLabel((String)ergebnisListe.get(j));
			xwert.setForeground(Color.blue);
			xwert.setFont(new Font("Serif",2,12));

			// Label zur Anzeige des richtigen Ereignisses
			// positioniert neben den Auswahlboxen, wo Auswahl stattfand
			JLabel auswahl = new JLabel();
			if (Integer.parseInt((String)ergebnisListe.get(j+1)) == Timeout)
				auswahl.setText("Timeout");
			else
				auswahl.setText("TDACK");
			auswahl.setForeground(Color.blue);
			auswahl.setFont(new Font("Serif", 2, 12));

			jPanelErgebniseingabe.add(xwert);
			jPanelErgebniseingabe.add(auswahl);
			j +=2;
		}
		JLabel schwellenwerttext = new JLabel("ssthresh:");
		JLabel schwellenwert = new JLabel((String)ergebnisListe.get(ergebnisListe.size()-1));
		schwellenwerttext.setForeground(Color.blue);
		schwellenwerttext.setFont(new Font("Serif", 2, 12));
		schwellenwert.setForeground(Color.blue);
		schwellenwert.setFont(new Font("Serif", 2, 12));
		jPanelErgebniseingabe.add(schwellenwerttext);
		jPanelErgebniseingabe.add(schwellenwert);

		buttonSenden2.setEnabled(false);

		jScrollPane1.repaint();
		jScrollPane1.revalidate();


		return ergebnis;

	}
	catch (NullPointerException ign)
	{System.out.println("Zunächst Aufgabe erzeugen");
	 return false;}
  }


  /**  Aufgabe 3 erzeugen und anzeigen */
  void buttonAufgabe3Erzeugen_mouseClicked(MouseEvent e) {

	// Wenn Anzahl größer Bereich, dann Bereich beschränken
	if (Integer.parseInt(textFieldAnzahl3.getText()) > Integer.parseInt(textFieldRundenzahl3.getText()))
    	textFieldAnzahl3.setText(textFieldRundenzahl3.getText());

	// Ergebnispanels leeren und Layout festlegen
	// Layout ist OverlayLayout, um Ergebniskurve in selbem Panel
	// abbilden zu können
	panelAnzeigeErgebnisse3.removeAll();
	panelAnzeigeErgebnisse3.setLayout(new OverlayLayout(panelAnzeigeErgebnisse3));
    panelAnzeigeErgebnisse3.repaint();
    // Eingabefelder initialisiern
	textFieldAnfangspunkt.setText("1");
	textFieldEndpunkt.setText("1");
    // Parameter für Aufgabentyp holen
    int anzahl = Integer.parseInt(textFieldAnzahl3.getText());
    int bereich = Integer.parseInt(textFieldRundenzahl3.getText());
    // Klasse Aufgabentyp3 erzeugen
    aufgabe3 = new Aufgabentyp3(bereich, anzahl);
    // Aufgabe anzeigen
    textAreaAnzeigeAufgabe3.setText(aufgabe3.createAufgabe());
    // Label für Anzeige des Ergebnisses leeren
    labelErgebnis3.setText("");
    // Grafikklasse für Darstellung der Eingabekurve erzeugen
    // Übergabe von bereich zur richtigen Skalierung der x-Werte
    grafik3 = new DrawGrafik3(bereich);
    zeitbedarf3 = System.currentTimeMillis();
    ergebnis3 = new ArrayList();

    buttonSenden3.setEnabled(true);

  }



  /**  Teillösungen von Aufgabe 3 erfassen */
  void buttonWertEingeben_mouseClicked(MouseEvent e) {
   try
   {
	   // Eingeben der verschiedenen Funktionsteile
		// Funktion bis dahin zeichnen
		// ergebnis3 ist Liste aller bis dahin erfassten y-Werte
		if((Integer.parseInt(textFieldAnfangspunkt.getText()) > 0) && (Integer.parseInt(textFieldEndpunkt.getText()) > 0))
		{
			panelAnzeigeErgebnisse3.removeAll();
			ergebnis3 = grafik3.addFunktion(Integer.parseInt(textFieldAnfangspunkt.getText()), Integer.parseInt(textFieldEndpunkt.getText()), choiceFunktion.getSelectedItem());
			// Anzeige der Eingabekurve
			panelAnzeigeErgebnisse3.add(grafik3);
			panelAnzeigeErgebnisse3.repaint();
			myFrame.repaint();
		}
	}
	catch (NullPointerException ign)
	{System.out.println("Zunächst Aufgabe erzeugen");}
  }


  /** Lösung von Aufgabe 3 überprüfen und anzeigen */
  boolean buttonOK3_actionPerformed(ActionEvent e) {
    try
    {
		// Überprüfen der Ergebnisse durch Einzeichnen der Kurve sowie
		// durch Vergleich der Wertepaare, die eingegeben wurden
		// und der Wertepaare, die sich durch Berechnung intern ergeben
		boolean ergebnis = false;
		zeitbedarf3 = System.currentTimeMillis() - zeitbedarf3;
		ergebnis = aufgabe3.doCheck(ergebnis3);
		// Anzeige des Ergebnisses
		if (ergebnis == true)
			labelErgebnis3.setText("Richtig!");
		else
			labelErgebnis3.setText("Leider Falsch! Korrekte Kurve wird im Diagramm blau dargestellt.");

		// richtiges Ergebnis holen
		List ergebnisListe = new ArrayList();
		ergebnisListe = aufgabe3.getErgebnis();

		// Anzeige des richtigen Ergebnisses:
		DrawGrafik2 ergebnisGrafik = new DrawGrafik2(ergebnisListe);
		panelAnzeigeErgebnisse3.add(ergebnisGrafik);

		buttonSenden3.setEnabled(false);

		panelAnzeigeErgebnisse3.repaint();
		myFrame.repaint();

	return ergebnis;

   }
   catch (NullPointerException ign)
   {System.out.println("Zunächst Aufgabe erzeugen");
     return false;}
  }



  /** Reaktion auf Menüeinträge View */
  void aufgabentyp_ActionPerformed(ActionEvent e) {
		if (e.getSource() == jMenuItemAufgabentyp1){
			jTabbedPaneAufgabentypen.setSelectedIndex(0);
		}
		else if (e.getSource() == jMenuItemAufgabentyp2)
			jTabbedPaneAufgabentypen.setSelectedIndex(1);
		else if (e.getSource() == jMenuItemAufgabentyp3)
			jTabbedPaneAufgabentypen.setSelectedIndex(2);

			}


  /** Reaktion auf Menüeinträge in Einstellungen/ Customizing */
  void einstellungen_ActionPerformed(ActionEvent e)
		{
            JOptionPane pane = new JOptionPane();
            pane.setOptionType(JOptionPane.OK_CANCEL_OPTION);
            pane.setMessageType(JOptionPane.QUESTION_MESSAGE);
			pane.setWantsInput(true);
				if (e.getSource() ==jMenuItemAnzahlAktionen)
				{
            		pane.setMessage("Anzahl der Aktionen: ");
                	JDialog dialog = pane.createDialog(myFrame, "Anzahl der Aktionen");
                	dialog.show();
                	Integer selectedValue = (Integer)pane.getValue();
                	if(selectedValue.intValue() == JOptionPane.OK_OPTION)
                    {
                        String AnzahlAktionen = (String)pane.getInputValue();
                        try {
							int test = Integer.parseInt(AnzahlAktionen);
							// Setzen der Aktionsanzahlen
							textFieldAnzahl1.setText(AnzahlAktionen);
							textFieldAnzahl2.setText(AnzahlAktionen);
							textFieldAnzahl3.setText(AnzahlAktionen);
						}
						catch(Exception ign)
						{};
                    }
				}
				else if (e.getSource() == jMenuItemBereichx)
				{
					pane.setMessage("maximale Rundenzahl: ");
				    JDialog dialog = pane.createDialog(myFrame, "maximale Rundenzahl");
				    dialog.show();
                	Integer selectedValue = (Integer)pane.getValue();
                    if (selectedValue.intValue() == JOptionPane.OK_OPTION)
                    {
			  			String Bereichx = (String)pane.getInputValue();
			  			try {
							int test = Integer.parseInt(Bereichx);
                        	// Setzen der Rundenzahlen
			 				textFieldRundenzahl1.setText(Bereichx);
			  				textFieldRundenzahl2.setText(Bereichx);
			  				textFieldRundenzahl3.setText(Bereichx);
						}
						catch (Exception ign)
						{};
                    }
				}
			}



  void quit_windowClosing(WindowEvent e) {
	  this.stop();
	  e.getWindow().dispose();
  }



  /** Reaktion auf Menüeinträge in Program */
  void program_ActionPerformed(ActionEvent e) {
	  if (e.getSource() == jMenuItemQuit)
	  {
	  	this.stop();
	  	myFrame.dispose();
	  }
  }


  /** Reaktion auf Menü Help */
  void help_ActionPerformed(ActionEvent e) throws java.net.MalformedURLException{
	  AppletContext AppContext = this.getAppletContext();
	  AppContext.showDocument(new URL(this.getDocumentBase(),"onlinehilfe.htm"),"_blank");
  }

  void buttonWertEingeben_actionPerformed(ActionEvent e) {

  }

  void buttonSenden1_mouseClicked(MouseEvent e) {

  	try
  	{
  		boolean ergebnis = buttonOK1_mouseClicked(e);

    	// Daten bezüglich Komplexität, Zeitbedarf und Qualität der Antwort an
		// Methode send() von Aufgabentyp1 übermitteln zur späteren Weiterverarbeitung
		// auf dem Server
		List sendParameter = new ArrayList();
		sendParameter.add(Long.toString(zeitbedarf1));
		sendParameter.add((new Boolean(ergebnis)).toString());
		sendParameter.add(textFieldAnzahl1.getText());
		sendParameter.add(textFieldRundenzahl1.getText());
		sendParameter.add(benutzer);
			sendParameter.add(passwort);
		sendParameter.add("kapp1");

		aufgabe1.send(sendParameter);

	}
	catch (NullPointerException ign)
	{}
  }

  void buttonSenden3_actionPerformed(ActionEvent e) {


	  try {
		  boolean ergebnis = buttonOK3_actionPerformed(e);

		  // Daten bezüglich Komplexität, Zeitbedarf und Qualität der Antwort an
		  // Methode send() von Aufgabentyp1 übermitteln zur späteren Weiterverarbeitung
		  // auf dem Server
		  List sendParameter = new ArrayList();
		  sendParameter.add(Long.toString(zeitbedarf3));
		  sendParameter.add((new Boolean(ergebnis)).toString());
		  sendParameter.add(textFieldAnzahl3.getText());
		  sendParameter.add(textFieldRundenzahl3.getText());
		  sendParameter.add(benutzer);
		  sendParameter.add(passwort);
		  sendParameter.add("kapp3");
		  aufgabe3.send(sendParameter);

	 	}
	 catch(NullPointerException ign)
	 {}


  }

  void buttonSenden2_mouseClicked(MouseEvent e) {

	try
	{
	  boolean ergebnis = buttonOK2_mouseClicked(e);

	  // Daten bezüglich Komplexität, Zeitbedarf und Qualität der Antwort an
	  // Methode send() von Aufgabentyp1 übermitteln zur späteren Weiterverarbeitung
	  // auf dem Server
	  List sendParameter = new ArrayList();
	  sendParameter.add(Long.toString(zeitbedarf2));
	  sendParameter.add((new Boolean(ergebnis)).toString());
	  sendParameter.add(textFieldAnzahl2.getText());
	  sendParameter.add(textFieldRundenzahl2.getText());
	  sendParameter.add(benutzer);
	  sendParameter.add(passwort);
	  sendParameter.add("kapp2");
	  aufgabe2.send(sendParameter);
	}
	catch (NullPointerException ign)
	{}
  }

}
