import java.util.List;
import java.util.ArrayList;
import java.lang.reflect.Array;


/** Aufgabentyp3:
  * Nach Vorgabe zufällig ermittelter Zeitpunkte und dort
  * eingetretenen Aktionen soll der Benutzer den Verlauf des
  * Congestion Window angeben. Dabei soll er angeben, in welchen
  * Bereichen welche Funktion verläuft und wie die Congestion Window
  * Größen in/vor den Aktionszeitpunkten aussehen. Auch der Schwellenwert,
  * der mit 64 initialisiert wurde, soll angegeben werden.*/
public class Aufgabentyp3 extends Aufgabe {
	List ergebnis;

	public Aufgabentyp3(int bereichx, int anzahl)
	{
		super(bereichx, anzahl);
	}

	/** Erzeugt den Aufgabentext und gibt ihn an die Klasse Aufgabentrainer zurück */
	public String createAufgabe()
		{
			String anzeigetext ="";
			// Erstelle Aufgabentext
			for (int i=0; i<Array.getLength(aktionen); i++)
			{
				anzeigetext = anzeigetext + "Nach "+Integer.toString(aktionen[i][0])+" Runden kommt es zu einem ";
				if (aktionen[i][1] == Timeout)
					anzeigetext = anzeigetext + "Timeout. \n";
				else
					anzeigetext = anzeigetext + "TDACK. \n";
			}
			anzeigetext = anzeigetext + "Zeichnen sie den Verlauf des Congestion Windows.";
			return anzeigetext;
	}


	/** Erhält alle Benutzerspezifischen Daten zur späteren Abspeicherung und Auswertung.
	  * Dies sind beispielsweise Benutzername, Passwort, benötigte Zeit für die Aufgabe,
	  * Ergebnis der Aufgabe und Schwierigkeitsgrad */
	public void send(List SendParameter)
	{
		for (int i=0; i<SendParameter.size(); i++)
		{
			System.out.println(SendParameter.get(i));
		}
		results k1 = new results();
				k1.command ="ergeing";
				k1.appletid =(String)SendParameter.get(6);
				k1.id =(String)SendParameter.get(4);
				k1.password=(String)SendParameter.get(5);
				k1.difficulty=Integer.toString(Integer.parseInt((String)SendParameter.get(3))*Integer.parseInt((String)SendParameter.get(2)));

				if (SendParameter.get(1).equals("false"))
					k1.valuation = "+1";
				else
					k1.valuation = "-1";

				k1.time =(String)SendParameter.get(0);
				k1.status();

				k1.destip ="192.168.17.50";
				k1.destport = 3200;
				k1.send();
	    k1.status();
	}


	public void save(){};


	public List getErgebnis()
	{
		return ergebnis;
	}

	/** Kontrolliert die Benutzereingaben auf Richtigkeit */
	public boolean doCheck(List controls){
		// bekommt als ArrayList die Liste aller y-Werte
		// in der Reihenfolge aufsteigender x-Werte mit Schrittweite 1
		// übergeben.
		int cwndneu=1;
		int cwndalt=1;
		int j;
		ergebnis = new ArrayList();
		// Wenn Größe der übergebenen Liste nicht mit angegeben maximaler
		// Rundenanzahl übereinstimmt: Ergebnis falsch
		// Bestimmung der Liste aller y-Werte aus eigener Berechnung für
		// die Congestion Window Kurve für die x-Werte von 1 bisList.size()
		// bestimme für alle x von 1 bis bereichx
		for (int i=0; i<bereichx; i++)
		{
			int erg =getCongestionWindowResult(i+1);
			ergebnis.add(new Integer(erg));

		}
		// Vergleich der beiden Listen
		if (controls.equals(ergebnis) == true)
			return true;
		else
			return false;
	};


}