//package Aufgabe;


import java.util.HashMap;
import java.util.Map;
import java.util.List;
import java.util.ArrayList;
import java.awt.Graphics;
import java.awt.Panel;
import java.lang.Math;
import java.awt.Color;
import java.lang.reflect.Array;
import javax.swing.JComponent;

public class DrawGrafik3 extends JComponent
{
	Map wertepaare;
	int lastValue;
	int endpunkt;
	int [] xPoints;
	int [] werte;
	List ergebnis;

	public DrawGrafik3(int bereich)
	{
		wertepaare = new HashMap();
		lastValue=1;
		endpunkt=0;
		xPoints = new int[bereich];
		werte = new int[bereich];
		ergebnis = new ArrayList();
	}


	public List addFunktion(int anfangspunkt, int endpunkt, String funktion)
	{
		this.endpunkt=endpunkt;

		for (int i=anfangspunkt; i<= endpunkt; i++)
		{
			// wenn x-Wert noch nicht in HashMap enthalten
			// einfügen des Wertepaares
			if (wertepaare.containsKey(new Integer(i)) == false)
			{
				// feststellen des ywertes basierend auf letzem eingefügten
				// Wertepaar
				int y = getValue(i , funktion);
				wertepaare.put(new Integer(i), Integer.toString(y));
				xPoints[i-1] = i;
				werte[i-1] = y;
				ergebnis.add(new Integer(werte[i-1]));
			}
		}
		return ergebnis;
	}



	private int getValue (int xwert, String funktion)
	{
		if (funktion.equals("Timeout"))
			lastValue=1;
		else if (funktion.equals("TDACK"))
			lastValue=lastValue/2;
		else if (funktion.equals("2^x"))
			lastValue=2*lastValue;
		else if (funktion.equals("x^2"))
			lastValue=lastValue + xwert*xwert;
		else if (funktion.equals("e^x"))
			lastValue=lastValue+(int)Math.exp((float)xwert);
		else if (funktion.equals("linear"))
			lastValue++;
		else
			lastValue=-1;
		return lastValue;
	}


	private int [] skalierung(int[] x, String art)
	{
		int anzahl = Array.getLength(x);
		int [] i = new int[anzahl];
		int maxvalue = 0;
		int maxhoehe = getSize().height - 100;

		// maximalen y-Wert zur späteren Skalierung der y-Werte
		// feststellen.
		for (int z=0; z<anzahl; z++)
		{
			if (x[z] > maxvalue)
				maxvalue = x[z];
		}
		// Saklierung der Werte
		for (int j=0; j<anzahl; j++)
		{
			// wenn x-Achse skaliert werden soll, Bezug auf
			// Breite der zur Verfügung stehenden Komponente
			if (art.equals("x"))
				i[j]=(int) ((x[j]-1)*(getSize().width-10)/anzahl)+10;
			// Bei Skalierung der y-Achse Bezug auf Höhe der Komponente
			// sowie auf maximalen y-Wert
			else
				{
					if (maxvalue < maxhoehe)
						i[j]=(int) (getSize().height-x[j]*((getSize().height-100)/(maxvalue+20)))-100;
					else
						i[j] = maxhoehe - x[j] * maxhoehe/maxvalue;

				}
		}
		return i;
	}


	public void paint(Graphics g)
	{
		g.setColor(Color.red);
		this.setOpaque(false);

		// Skalierung der x-, und y-Werte
		// Werte passend auf Panelgröße transformieren
		int [] xwerte = skalierung(xPoints, "x");
		int [] ywerte = skalierung(werte, "y");


		// Linien zeichnen
		g.drawPolyline(xwerte, ywerte, endpunkt);
		g.setColor(Color.black);
		g.drawLine(10,0,10, getSize().height-100);
		g.drawLine(10,getSize().height-100,getSize().width, getSize().height-100);
	}
}